/* tslint:disable:no-bitwise */
// Decode
// Input 16 digit str
// Out unlock str
import { GetReverse } from './GetReverse'
import { CharSep } from './CharSep'
import { FullBin } from './FullBin'

export async function decode(input: string) {
  if (typeof input !== 'string' || input.length !== 16) {
    throw Error('Invalid input')
  }
  const fConv = new Int32Array(1)

  return CharSep(input, 0, 8)
    .then((data1) => {
      fConv[0] = parseInt(data1, 16)
      return CharSep(input, 8, 8)
    })
    .then((data2) => {
      const sConv = new Int32Array(1)
      sConv[0] = parseInt(data2, 16)
      return sConv[0]
    })
    .then((bin) => {
      const unbit = FullBin((bin >>> 0).toString(2), 32)
      return unbit
    })
    .then((unbit) => {
      return GetReverse(unbit)
    })
    .then((fin) => {
      const test = new Int32Array(1)
      test[0] = parseInt(fin, 2)
      const secondPartRev = test[0]
      return secondPartRev
    })
    .then((secondPartRev) => {
      const xor = new Int32Array(1)
      xor[0] = fConv[0] ^ secondPartRev
      return xor[0]
    })
    .then((xor) => {
      const ret = new Int32Array(1)
      ret[0] = xor - 0xE010A11
      return ret[0]
    })
    .then((ret) => {
      const hex = (ret >>> 0).toString(16)
      const final = FullBin(hex, 8)
      return final
    })
    .catch((err) => {
      throw err
    })
}
